
    Unit User;

{-----------------------------------------------------------------------}
                               INTERFACE
{-----------------------------------------------------------------------}

    Procedure GetBoxCode;
    Procedure GetTCode;

    Function  Machine: Boolean;

{-----------------------------------------------------------------------}
                            IMPLEMENTATION
{-----------------------------------------------------------------------}

    Uses  Crt,Types,Base;

    Var  {--------------------------------------------------------------}

              i: Integer;
    {................................................}

{-----------------------------------------------------------------------}

    Procedure GetBoxCode;
    Begin
     With Sys do With Spindle^ do
     Case ReadCD(47)+ReadCD(48)*2 Of
        1: iBox:=1;
        2: iBox:=2;
      else iBox:=0;
     end;
    End;

{-----------------------------------------------------------------------}

    Procedure GetTCode;
    Begin
    With Sys do
    begin
     T0:=1;
    end;
    End;

{-----------------------------------------------------------------------}

    Procedure Auto; far;
    var
                i: Byte;
    Begin
    With Sys do
    begin

  {..............................................................}
  {Command}

    {................................................}
    {Stop MANU}

     if ((RGS[4] =5) and (RGS[5] =3) and
     (Button[SB.CycleOn].Last =0)) then RGS[5]:=2;

    {................................................}
    {Change screen}

     i:=ExtendKey and 6;
     if (i =6) and (i> RGS[13]) and (RGS[12] <4) then
     Case RGS[12] of
      0: RGS[12]:=5;
      1: RGS[12]:=6;
      2: RGS[12]:=4;
     end;
     RGS[13]:=i;

  {..............................................................}
  {M06}

     Check(45,0,185,50);
     Check(29,0,179,50);
     Check(43,1,177,50);

  {..............................................................}
  {CCI}

     if ReadCD(75) =0 then
     begin
      With Timer.WaitCCI do if Count <1 then
      if ReadCD(26)> 0 then
      begin
       WriteCD(75,1);
       With Timer.WorkCCI do Count:=Store;
       With Send do if Next =0 then Next:=62;
      end else
      begin RunTimeError.Next:=180; Count:=Store; end;
     end else
     begin
      With Timer.WorkCCI do
      if (ReadCD(28)> 0) or (Count <1) then
      begin
       if TableIO[28]^.Value =0 then RunTimeError.Next:=181;
       WriteCD(75,0);
       With Timer.WaitCCI do Count:=Store;
      end;
     end;

  {..............................................................}
  {Stop}

     for i:=1 to iA do With Axis[i]^ do
     if Abs(Lost)> CLimit.Low then
     begin
      Case i Of
       1..3: WriteCD(77+i,0);
          4: WriteCD(77,0);
          5: WriteCD(82,0);
      end;
      RunTimeError.Next:=156; Error[156]^[29]:=Letter;
     end;

     Check(64,0,139,50);
     Check(65,0,138,50);
     Check(62,0,137,50);
     if RunTimeError.Next =137 then WriteCD(80,0);

  {..............................................................}
  {Spindle}

     With Spindle^ do if Active <>0 then
     begin
      if Timer.Spindle.Count <1 then
      begin
       Check(56,0,127,50);
       Check(55,1,125,50);
      end;
      Check(30,0,135,50);
      Check(32,0,136,50);
      Check(50,0,134,50);
      Check(53,0,131,50);
      Check(60,0,133,50);
     end;
  {..............................................................}
  {X}

     Check(61,0,151,50);
     if RunTimeError.Next =151 then WriteCD(78,0);

  {..................................................}
  {Y}

     Check(59,0,152,50);
     if RunTimeError.Next =152 then WriteCD(79,0);

  {..................................................}
  {Z}

     Check(57,0,153,50);
     if RunTimeError.Next =153 then WriteCD(80,0);

  {..................................................}
  {A}

     Check(54,0,154,50);
     if RunTimeError.Next =154 then WriteCD(77,0);

  {..................................................}
  {B}

     Check(58,0,155,50);
     if RunTimeError.Next =155 then WriteCD(82,0);

  {..............................................................}
  {Fatal machine}

     Check(2,0,100,10);

    {............................................................}

     for i:=1 to iA do With Axis[i]^ do
     if Abs(Lost)> CLimit.High then
     begin RunTimeError.Next:=110; Error[110]^[36]:=Letter; end;

     Check(27,1,109,10);
     Check(03,0,108,10);
     Check(51,0,106,10);
     Check(25,0,103,10);
     Check(63,0,102,10);
     Check(35,0,101,10);

  {..............................................................}
  {Frozen}

     With Switch[SW.Frozen] do if Change then
     begin
      i:=0;
      Case Last of
       1: begin WriteCD(Liquid,1); i:=54; end;
       0: begin WriteCD(Liquid,0); i:=55; end;
       2: if RGS[4] in [1,2] then With UStart^.Stack do
          begin
           if Frozen and 8> 0 then
           begin WriteCD(Liquid,1); i:=54; end else WriteCD(Liquid,0);
           if Frozen =0 then i:=55;
          end;
     else i:=13;
      end;
      With Send do if (Next =0) or (Next> 49) then Next:=i;
      Change:=False; RGS[8]:=0;
     end;

  {..............................................................}
  {Light}

     With Switch[9] do if Change then
     begin
      if Last> 0 then WriteCD(84,1) else WriteCD(84,0);
      Change:=False;
     end;

  {..............................................................}

    end;
    End;

{-----------------------------------------------------------------------}

    Function Machine: Boolean;
    label STOP;

    Begin
    With Sys do
    begin

     UserError:=0; Machine:=True;
  {.....................................................................}
  {Control automat}

     if (not Signal(03,1,108,5,0.1))
     or (not Signal(51,1,106,5,0.1))
     or (not Signal(63,1,102,5,0.1))
     or (not Signal(35,1,101,5,0.1)) then goto Stop;

  {.....................................................................}
  {Ready}

     WriteCD(74,1);
     if not Signal(02,1,100,0,0.2) then goto Stop;

  {.....................................................................}
  {Pressure}

     if not Signal(25,1,103,0,0.1) then goto Stop;

  {.....................................................................}
  {Automat XYZAB}

     WriteCD(95,1);
     WriteCD(96,1);
     if not Delay(0) then goto Stop;

  {.....................................................................}
  {XYZAB}

     WriteCD(78,1);
     if not Signal(61,1,151,0,0.1) then goto Stop;

     WriteCD(79,1);
     if not Signal(59,1,152,0,0.1) then goto Stop;

     WriteCD(80,1);
     if not Signal(57,1,153,0,0.1) then goto Stop;

     WriteCD(77,1);
     if not Signal(54,1,154,0,0.1) then goto Stop;

     WriteCD(82,1);
     if not Signal(58,1,155,0,0.1) then goto Stop;

  {.....................................................................}
  {Free Z}

     if not Signal(62,1,137,0,0.1) then goto Stop;

  {.....................................................................}
  {Check automat}

     if (not Signal(03,1,108,5,0.1))
     or (not Signal(51,1,106,5,0.1))
     or (not Signal(63,1,102,5,0.1))
     or (not Signal(35,1,101,5,0.1))
     or (not Signal(02,1,100,5,0.1)) then goto Stop;

  {.....................................................................}

     GetBoxCode; GetTCode;
     Switch[SW.Frozen].Change:=False;
     Switch[8].Change:=False;

     Exit; Stop:
     Machine:=False; RunTimeError.Next:=UserError;
    end;
    End;

{-----------------------------------------------------------------------}
{                            H -FUNCTIONS                               }
{-----------------------------------------------------------------------}

   Procedure M04; far; forward;
   Procedure M05; far; forward;

{-----------------------------------------------------------------------}
  {-----------------------------------------------------------------------}
  {Keep instrument}

   Procedure H00; far;
   Label Stop;

   Begin
   With Sys do
   begin
  {..............................................................}

    if Signal(50,1,0,0.5,0.05) and Signal(53,0,0,0.5,0.05) then
    begin Send.Next:=53; Exit; end;

    UserError:=0;
  {..............................................................}

    WriteCD(94,0);
    if (not Signal(50,1,134,0,0.1))
    or (not Signal(53,1,131,0,0.1)) then goto Stop;
  {..............................................................}

    WriteCD(83,0); Send.Next:=53;
    Exit; Stop:
    if UserError> 0 then CycleError.Next:=UserError;
   end;
   End;

  {---------------------------------------------------------------------}
  {Free instrument}

   Procedure H01; far;
   Label Stop;

   Begin
   With Sys do
   begin
  {..............................................................}

    if Signal(50,0,0,0.5,0.05) and Signal(53,0,0,0.5,0.05) then
    begin Send.Next:=52; Exit; end;
    if Spindle^.Active <>0 then begin Send.Next:=58; Exit; end;

    UserError:=0;
  {..............................................................}

    WriteCD(94,1);
    if (not Signal(50,0,134,0,0.1))
    or (not Signal(53,0,132,0,0.1)) then goto Stop;
  {..............................................................}

    WriteCD(83,0); Send.Next:=52;
    Exit; Stop:
    if UserError> 0 then CycleError.Next:=UserError;
   end;
   End;

  {-----------------------------------------------------------------------}
  {Turn spindle}

   Procedure H02; far;
   Label Stop;

   Begin
   With Sys do With Spindle^ do
   begin
  {........................................................................}

    M05;
    UserError:=0;

    GetBoxCode;
    if iBox =0 then begin UserError:=130; goto Stop; end;
    if (not Signal(50,1,134,5,0.1))
    or (not Signal(53,1,131,5,0.1)) then goto Stop;
  {.........................................................}

    WriteCD(81,1);
    if not Signal(60,1,133,0,0.1) then goto Stop;
    With Axis[nA]^ do
    UDS:=Round(Dkv(Round(FHome.Low),nA)*Box[iBox].Zub);
    if not Signal(56,1,127,0,0.2) then goto Stop;
  {...................................................................}

    if not Delay(5) then goto Stop;
    M05;
  {...................................................................}

    Send.Next:=65;
    Exit; Stop:
    M05;
    if UserError> 0 then CycleError.Next:=UserError;
   end;
   End;

{-----------------------------------------------------------------------}
{                            M -FUNCTIONS                               }
{-----------------------------------------------------------------------}

   Procedure M00; far;
   Begin
   With Sys do

   if RGS[4] <3 then
   begin
    M05;
    RGS[5]:=2;
    RGS[6]:=31;
    RGS[2]:=1;
   end;
   End;

{-----------------------------------------------------------------------}

   Procedure M01; far;
   Begin
   With Sys do

   if UCod.USO> 0 then M00;
   End;

{-----------------------------------------------------------------------}

   Procedure M02; far;
   Begin

   if RGS[4] <3 then
   begin
    M05;
    RGS[5]:=0;
    RGS[6]:=43;
   end;
   End;

{-----------------------------------------------------------------------}

   Procedure M03; far;
   Label Stop;

   Var  Direct: Byte;

   Begin
   With Sys do With Spindle^ do
   begin
  {.........................................................}

    UserError:=0; Direct:=MHCode;
  {.........................................................}

    if UStart^.Stack.Transmit =0 then
    begin
     for MHCode:=1 to nBox do With Box[MHCode] do
     if (SCode>= Low) and (SCode <=High) then Break;
     Inc(MHCode,40);
     M04; if UserError> 0 then goto Stop;
    end;
  {.........................................................}

    SetS:=SCode;
    if SetS =0 then begin UserError:=128; goto Stop; end;

    GetBoxCode;
    if iBox= 0 then begin UserError:=130; goto Stop; end else
    With Box[iBox] do
    if (SetS <Low) or (SetS> High) then
    begin UserError:=129; goto Stop; end;

    if (not Signal(50,1,134,5,0.1))
    or (not Signal(53,1,131,5,0.1)) then goto Stop;
  {.........................................................}

    PutS:=SetS*CorrectS.Value Div 100;
    With Box[iBox] do
    if PutS> High then PutS:=High else
    if PutS <Low  then PutS:=Low;

    WriteCD(81,1);
    if not Signal(60,1,133,0,0.1) then goto Stop;

    if Odd(Direct) then Active:=1 else Active:=-1;
    PutD:=Round(Dkv(PutS,nA)*Box[iBox].Zub*Active);
    While PutD <>Axis[nA]^.UDS do if RGS[5] <2 then goto STOP;

    if not Signal(55,0,125,0,0.2) then goto Stop;
    if not Signal(56,1,127,0,0.2) then goto Stop;
  {.........................................................}

    Send.Next:=50; Switch[SW.S].Change:=True; RGS[8]:=0;
    Exit; Stop:
    M05;
    if UserError> 0 then CycleError.Next:=UserError;
   end;
   End;

{-----------------------------------------------------------------------}

   Procedure M04;
   Label Stop;

   Const
           CODw: array[1..Max_Box] of Byte = (01,02);
           CODr: array[1..Max_Box] of Byte = (01,02);
   Var
           COG,SHP,NewBox: ShortInt;

   Begin
   With Sys do With Spindle^ do
   begin
  {.....................................................................}

    NewBox:=MHCode-40;
    if NewBox =0 then begin Send.Next:=75; Exit; end;
    GetBoxCode;
    if NewBox =iBox then begin Send.Next:=57; Exit; end;

    COG:=ReadCD(Liquid); SHP:=Active;
    M05;

    UserError:=0;
    if (not Signal(50,1,134,5,0.1))
    or (not Signal(53,1,131,5,0.1)) then goto Stop;

  {.................................................................}

    WriteCD(81,1);
    if not Signal(60,1,133,0,0.1) then goto Stop;

    With Axis[nA]^ do if iBox =0 then UDS:=400 else
    UDS:=Round(Dkv(Round(FHome.Low),nA)*Box[iBox].Zub);
    if not Signal(56,1,127,0,0.2) then goto Stop;

  {.................................................................}

    WriteCD(89,CODw[NewBox] and 1);
    WriteCD(90,CODw[NewBox] shr 1 and 1);

    if (not Signal(47,CODr[NewBox] and 1,130,0,0.1))
    or (not Signal(48,CODr[NewBox] shr 1 and 1,130,0,0.1)) then
    goto Stop;

    WriteCD(89,0); WriteCD(90,0);
  {.................................................................}

    iBox:=NewBox;

    if COG> 0 then WriteCD(Liquid,1);
    if SHP <>0 then
    begin
     if SHP> 0 then MHCode:=3 else MHCode:=4;
     M03; if UserError> 0 then goto Stop;
    end
    else M05;
  {.....................................................................}

    Send.Next:=57;

    Exit; Stop:
    WriteCD(89,0); WriteCD(90,0);
    M05;
    if UserError> 0 then CycleError.Next:=UserError;
   end;
   End;

{-----------------------------------------------------------------------}

   Procedure M05;
   Begin
   With Sys do With Spindle^ do
   begin
  {.....................................................................}

    if Active <>0 then With Timer.Cycle do
    begin
     PutD:=0; Send.Next:=51; Count:=Store;
     repeat
      if Count <1 then begin CycleError.Next:=126; Break; end;
     until (RGS[5] <2) or (Axis[nA]^.UDS =0);
     if not Delay(0) then;
    end;

    WriteCD(81,0); ReSetSpindle;
    WriteCD(Liquid,0);
  {.....................................................................}

    RGS[8]:=0;

   end;
   End;

{-----------------------------------------------------------------------}

   Procedure M06; far;
   Begin
  {................................................}

   if RGS[4] <3 then
   begin
    RGS[5]:=2; RGS[6]:=46; RGS[2]:=1;
   end;
   End;

{-----------------------------------------------------------------------}

   Procedure M08; far;
   Begin

   With Sys do
   begin
    Case Switch[SW.Frozen].Last of
    0,1: Send.Next:=56;
      2: begin WriteCD(Liquid,1); Send.Next:=54; end;
    else Send.Next:=13;
    end;
   end;
   End;

{-----------------------------------------------------------------------}

   Procedure M09; far;
   Begin

   With Sys do
   begin
    Case Switch[SW.Frozen].Last of
    0,1: Send.Next:=56;
      2: begin WriteCD(Liquid,0); Send.Next:=55; end;
    else Send.Next:=13;
    end;
   end;
   End;

{-----------------------------------------------------------------------}

   Procedure M13; far;
   Begin
    M03;
    With Sys do if UserError =0 then WriteCD(Liquid,1);
   End;

{-----------------------------------------------------------------------}

   Procedure M30; far;
   Begin
   End;

{-----------------------------------------------------------------------}
{                                INIT                                   }
{-----------------------------------------------------------------------}

   Begin
   With Sys do
   begin
  {.......................................................}

    ModeStr[0]:='...?';
    ModeStr[1]:='MDI ';
    ModeStr[2]:='MANU';
    ModeStr[3]:='JOG ';
    ModeStr[4]:='STEP';
    ModeStr[5]:='AUTO';
    ModeStr[6]:='PROF';
    ModeStr[7]:='HOME';
    ModeStr[8]:='ESC ';

  {.......................................................}

    Liquid:=76;
    UserRunTime:=Auto;
  {.......................................................}
  {M-procedure}

    With MProc[00] do begin Refer:=M00; State:=0; end;
    With MProc[01] do begin Refer:=M01; State:=0; end;
    With MProc[02] do begin Refer:=M02; State:=0; end;
    With MProc[03] do begin Refer:=M03; State:=1; end;
    With MProc[04] do begin Refer:=M03; State:=1; end;
    With MProc[40] do begin Refer:=M04; State:=3; end;
    With MProc[41] do begin Refer:=M04; State:=3; end;
    With MProc[42] do begin Refer:=M04; State:=3; end;
    With MProc[05] do begin Refer:=M05; State:=0; end;
    With MProc[06] do begin Refer:=M06; State:=0; end;
    With MProc[08] do begin Refer:=M08; State:=1; end;
    With MProc[09] do begin Refer:=M09; State:=1; end;
    With MProc[13] do begin Refer:=M13; State:=1; end;
    With MProc[14] do begin Refer:=M13; State:=1; end;
    With MProc[30] do begin Refer:=M30; State:=0; end;
  {.......................................................}
  {H-procedure}

    With HProc[00] do begin Refer:=H00; State:=0; end;
    With HProc[01] do begin Refer:=H01; State:=0; end;
    With HProc[02] do begin Refer:=H02; State:=0; end;
  {.......................................................}

   end;

{-----------------------------------------------------------------------}


   End.